import { CfnTag } from 'aws-cdk-lib';
import * as controltower from 'aws-cdk-lib/aws-controltower';
import { Construct } from 'constructs';
import { IDlzControlTowerControl } from './controls';
import { Region } from '../../data-landing-zone-types';
import { IReportResource, ReportResource } from '../../lib';
export interface DlzControlTowerEnabledControlProps {
    readonly controlTowerRegion: Region;
    readonly controlTowerAccountId: string;
    readonly organizationId: string;
    readonly appliedOu: string;
    readonly control: IDlzControlTowerControl;
    readonly tags?: CfnTag[];
}
export declare class DlzControlTowerEnabledControl implements IReportResource {
    /**
     * Check if the control can be applied to the Security OU. Only LEGACY controls can be applied to the Security OU.
     */
    static canBeAppliedToSecurityOU(control: IDlzControlTowerControl): boolean;
    readonly control: controltower.CfnEnabledControl;
    readonly reportResource: ReportResource;
    constructor(scope: Construct, id: string, props: DlzControlTowerEnabledControlProps);
}
