import { DlzControlTowerControlFormat, IDlzControlTowerControl, DlzControlTowerStandardControls } from '../index';
/**
 * Detect Amazon RDS database instances that are not encrypting their underlying storage.
 *
 * Format: Legacy Control
 * https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#disallow-rds-storage-unencrypted
 */
export declare class AWS_GR_RDS_STORAGE_ENCRYPTED implements IDlzControlTowerControl {
    readonly controlFriendlyName = DlzControlTowerStandardControls['AWS_GR_RDS_STORAGE_ENCRYPTED'];
    readonly description = "Detect Amazon RDS database instances that are not encrypting their underlying storage.";
    readonly format = DlzControlTowerControlFormat.LEGACY;
    readonly externalLink = "https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#disallow-rds-storage-unencrypted";
    readonly controlIdName: {
        euWest1: string;
        usEast1: string;
    };
}
