import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_CreateGroupMembershipCommand, se_CreateGroupMembershipCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class CreateGroupMembershipCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSIdentityStore", "CreateGroupMembership", {})
    .n("IdentitystoreClient", "CreateGroupMembershipCommand")
    .f(void 0, void 0)
    .ser(se_CreateGroupMembershipCommand)
    .de(de_CreateGroupMembershipCommand)
    .build() {
}
