import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetGroupIdRequestFilterSensitiveLog } from "../models/models_0";
import { de_GetGroupIdCommand, se_GetGroupIdCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class GetGroupIdCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSIdentityStore", "GetGroupId", {})
    .n("IdentitystoreClient", "GetGroupIdCommand")
    .f(GetGroupIdRequestFilterSensitiveLog, void 0)
    .ser(se_GetGroupIdCommand)
    .de(de_GetGroupIdCommand)
    .build() {
}
