import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetUserIdRequestFilterSensitiveLog } from "../models/models_0";
import { de_GetUserIdCommand, se_GetUserIdCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class GetUserIdCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSIdentityStore", "GetUserId", {})
    .n("IdentitystoreClient", "GetUserIdCommand")
    .f(GetUserIdRequestFilterSensitiveLog, void 0)
    .ser(se_GetUserIdCommand)
    .de(de_GetUserIdCommand)
    .build() {
}
