import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  CreateGroupCommandInput,
  CreateGroupCommandOutput,
} from "../commands/CreateGroupCommand";
import {
  CreateGroupMembershipCommandInput,
  CreateGroupMembershipCommandOutput,
} from "../commands/CreateGroupMembershipCommand";
import {
  CreateUserCommandInput,
  CreateUserCommandOutput,
} from "../commands/CreateUserCommand";
import {
  DeleteGroupCommandInput,
  DeleteGroupCommandOutput,
} from "../commands/DeleteGroupCommand";
import {
  DeleteGroupMembershipCommandInput,
  DeleteGroupMembershipCommandOutput,
} from "../commands/DeleteGroupMembershipCommand";
import {
  DeleteUserCommandInput,
  DeleteUserCommandOutput,
} from "../commands/DeleteUserCommand";
import {
  DescribeGroupCommandInput,
  DescribeGroupCommandOutput,
} from "../commands/DescribeGroupCommand";
import {
  DescribeGroupMembershipCommandInput,
  DescribeGroupMembershipCommandOutput,
} from "../commands/DescribeGroupMembershipCommand";
import {
  DescribeUserCommandInput,
  DescribeUserCommandOutput,
} from "../commands/DescribeUserCommand";
import {
  GetGroupIdCommandInput,
  GetGroupIdCommandOutput,
} from "../commands/GetGroupIdCommand";
import {
  GetGroupMembershipIdCommandInput,
  GetGroupMembershipIdCommandOutput,
} from "../commands/GetGroupMembershipIdCommand";
import {
  GetUserIdCommandInput,
  GetUserIdCommandOutput,
} from "../commands/GetUserIdCommand";
import {
  IsMemberInGroupsCommandInput,
  IsMemberInGroupsCommandOutput,
} from "../commands/IsMemberInGroupsCommand";
import {
  ListGroupMembershipsCommandInput,
  ListGroupMembershipsCommandOutput,
} from "../commands/ListGroupMembershipsCommand";
import {
  ListGroupMembershipsForMemberCommandInput,
  ListGroupMembershipsForMemberCommandOutput,
} from "../commands/ListGroupMembershipsForMemberCommand";
import {
  ListGroupsCommandInput,
  ListGroupsCommandOutput,
} from "../commands/ListGroupsCommand";
import {
  ListUsersCommandInput,
  ListUsersCommandOutput,
} from "../commands/ListUsersCommand";
import {
  UpdateGroupCommandInput,
  UpdateGroupCommandOutput,
} from "../commands/UpdateGroupCommand";
import {
  UpdateUserCommandInput,
  UpdateUserCommandOutput,
} from "../commands/UpdateUserCommand";
export declare const se_CreateGroupCommand: (
  input: CreateGroupCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateGroupMembershipCommand: (
  input: CreateGroupMembershipCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateUserCommand: (
  input: CreateUserCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteGroupCommand: (
  input: DeleteGroupCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteGroupMembershipCommand: (
  input: DeleteGroupMembershipCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteUserCommand: (
  input: DeleteUserCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeGroupCommand: (
  input: DescribeGroupCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeGroupMembershipCommand: (
  input: DescribeGroupMembershipCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DescribeUserCommand: (
  input: DescribeUserCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetGroupIdCommand: (
  input: GetGroupIdCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetGroupMembershipIdCommand: (
  input: GetGroupMembershipIdCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetUserIdCommand: (
  input: GetUserIdCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_IsMemberInGroupsCommand: (
  input: IsMemberInGroupsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListGroupMembershipsCommand: (
  input: ListGroupMembershipsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListGroupMembershipsForMemberCommand: (
  input: ListGroupMembershipsForMemberCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListGroupsCommand: (
  input: ListGroupsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListUsersCommand: (
  input: ListUsersCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateGroupCommand: (
  input: UpdateGroupCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateUserCommand: (
  input: UpdateUserCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_CreateGroupCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateGroupCommandOutput>;
export declare const de_CreateGroupMembershipCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateGroupMembershipCommandOutput>;
export declare const de_CreateUserCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateUserCommandOutput>;
export declare const de_DeleteGroupCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteGroupCommandOutput>;
export declare const de_DeleteGroupMembershipCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteGroupMembershipCommandOutput>;
export declare const de_DeleteUserCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteUserCommandOutput>;
export declare const de_DescribeGroupCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeGroupCommandOutput>;
export declare const de_DescribeGroupMembershipCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeGroupMembershipCommandOutput>;
export declare const de_DescribeUserCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeUserCommandOutput>;
export declare const de_GetGroupIdCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetGroupIdCommandOutput>;
export declare const de_GetGroupMembershipIdCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetGroupMembershipIdCommandOutput>;
export declare const de_GetUserIdCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetUserIdCommandOutput>;
export declare const de_IsMemberInGroupsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<IsMemberInGroupsCommandOutput>;
export declare const de_ListGroupMembershipsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListGroupMembershipsCommandOutput>;
export declare const de_ListGroupMembershipsForMemberCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListGroupMembershipsForMemberCommandOutput>;
export declare const de_ListGroupsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListGroupsCommandOutput>;
export declare const de_ListUsersCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListUsersCommandOutput>;
export declare const de_UpdateGroupCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateGroupCommandOutput>;
export declare const de_UpdateUserCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateUserCommandOutput>;
