import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AttachCustomerManagedPolicyReferenceToPermissionSetCommandInput, AttachCustomerManagedPolicyReferenceToPermissionSetCommandOutput } from "../commands/AttachCustomerManagedPolicyReferenceToPermissionSetCommand";
import { AttachManagedPolicyToPermissionSetCommandInput, AttachManagedPolicyToPermissionSetCommandOutput } from "../commands/AttachManagedPolicyToPermissionSetCommand";
import { CreateAccountAssignmentCommandInput, CreateAccountAssignmentCommandOutput } from "../commands/CreateAccountAssignmentCommand";
import { CreateApplicationAssignmentCommandInput, CreateApplicationAssignmentCommandOutput } from "../commands/CreateApplicationAssignmentCommand";
import { CreateApplicationCommandInput, CreateApplicationCommandOutput } from "../commands/CreateApplicationCommand";
import { CreateInstanceAccessControlAttributeConfigurationCommandInput, CreateInstanceAccessControlAttributeConfigurationCommandOutput } from "../commands/CreateInstanceAccessControlAttributeConfigurationCommand";
import { CreateInstanceCommandInput, CreateInstanceCommandOutput } from "../commands/CreateInstanceCommand";
import { CreatePermissionSetCommandInput, CreatePermissionSetCommandOutput } from "../commands/CreatePermissionSetCommand";
import { CreateTrustedTokenIssuerCommandInput, CreateTrustedTokenIssuerCommandOutput } from "../commands/CreateTrustedTokenIssuerCommand";
import { DeleteAccountAssignmentCommandInput, DeleteAccountAssignmentCommandOutput } from "../commands/DeleteAccountAssignmentCommand";
import { DeleteApplicationAccessScopeCommandInput, DeleteApplicationAccessScopeCommandOutput } from "../commands/DeleteApplicationAccessScopeCommand";
import { DeleteApplicationAssignmentCommandInput, DeleteApplicationAssignmentCommandOutput } from "../commands/DeleteApplicationAssignmentCommand";
import { DeleteApplicationAuthenticationMethodCommandInput, DeleteApplicationAuthenticationMethodCommandOutput } from "../commands/DeleteApplicationAuthenticationMethodCommand";
import { DeleteApplicationCommandInput, DeleteApplicationCommandOutput } from "../commands/DeleteApplicationCommand";
import { DeleteApplicationGrantCommandInput, DeleteApplicationGrantCommandOutput } from "../commands/DeleteApplicationGrantCommand";
import { DeleteInlinePolicyFromPermissionSetCommandInput, DeleteInlinePolicyFromPermissionSetCommandOutput } from "../commands/DeleteInlinePolicyFromPermissionSetCommand";
import { DeleteInstanceAccessControlAttributeConfigurationCommandInput, DeleteInstanceAccessControlAttributeConfigurationCommandOutput } from "../commands/DeleteInstanceAccessControlAttributeConfigurationCommand";
import { DeleteInstanceCommandInput, DeleteInstanceCommandOutput } from "../commands/DeleteInstanceCommand";
import { DeletePermissionsBoundaryFromPermissionSetCommandInput, DeletePermissionsBoundaryFromPermissionSetCommandOutput } from "../commands/DeletePermissionsBoundaryFromPermissionSetCommand";
import { DeletePermissionSetCommandInput, DeletePermissionSetCommandOutput } from "../commands/DeletePermissionSetCommand";
import { DeleteTrustedTokenIssuerCommandInput, DeleteTrustedTokenIssuerCommandOutput } from "../commands/DeleteTrustedTokenIssuerCommand";
import { DescribeAccountAssignmentCreationStatusCommandInput, DescribeAccountAssignmentCreationStatusCommandOutput } from "../commands/DescribeAccountAssignmentCreationStatusCommand";
import { DescribeAccountAssignmentDeletionStatusCommandInput, DescribeAccountAssignmentDeletionStatusCommandOutput } from "../commands/DescribeAccountAssignmentDeletionStatusCommand";
import { DescribeApplicationAssignmentCommandInput, DescribeApplicationAssignmentCommandOutput } from "../commands/DescribeApplicationAssignmentCommand";
import { DescribeApplicationCommandInput, DescribeApplicationCommandOutput } from "../commands/DescribeApplicationCommand";
import { DescribeApplicationProviderCommandInput, DescribeApplicationProviderCommandOutput } from "../commands/DescribeApplicationProviderCommand";
import { DescribeInstanceAccessControlAttributeConfigurationCommandInput, DescribeInstanceAccessControlAttributeConfigurationCommandOutput } from "../commands/DescribeInstanceAccessControlAttributeConfigurationCommand";
import { DescribeInstanceCommandInput, DescribeInstanceCommandOutput } from "../commands/DescribeInstanceCommand";
import { DescribePermissionSetCommandInput, DescribePermissionSetCommandOutput } from "../commands/DescribePermissionSetCommand";
import { DescribePermissionSetProvisioningStatusCommandInput, DescribePermissionSetProvisioningStatusCommandOutput } from "../commands/DescribePermissionSetProvisioningStatusCommand";
import { DescribeTrustedTokenIssuerCommandInput, DescribeTrustedTokenIssuerCommandOutput } from "../commands/DescribeTrustedTokenIssuerCommand";
import { DetachCustomerManagedPolicyReferenceFromPermissionSetCommandInput, DetachCustomerManagedPolicyReferenceFromPermissionSetCommandOutput } from "../commands/DetachCustomerManagedPolicyReferenceFromPermissionSetCommand";
import { DetachManagedPolicyFromPermissionSetCommandInput, DetachManagedPolicyFromPermissionSetCommandOutput } from "../commands/DetachManagedPolicyFromPermissionSetCommand";
import { GetApplicationAccessScopeCommandInput, GetApplicationAccessScopeCommandOutput } from "../commands/GetApplicationAccessScopeCommand";
import { GetApplicationAssignmentConfigurationCommandInput, GetApplicationAssignmentConfigurationCommandOutput } from "../commands/GetApplicationAssignmentConfigurationCommand";
import { GetApplicationAuthenticationMethodCommandInput, GetApplicationAuthenticationMethodCommandOutput } from "../commands/GetApplicationAuthenticationMethodCommand";
import { GetApplicationGrantCommandInput, GetApplicationGrantCommandOutput } from "../commands/GetApplicationGrantCommand";
import { GetInlinePolicyForPermissionSetCommandInput, GetInlinePolicyForPermissionSetCommandOutput } from "../commands/GetInlinePolicyForPermissionSetCommand";
import { GetPermissionsBoundaryForPermissionSetCommandInput, GetPermissionsBoundaryForPermissionSetCommandOutput } from "../commands/GetPermissionsBoundaryForPermissionSetCommand";
import { ListAccountAssignmentCreationStatusCommandInput, ListAccountAssignmentCreationStatusCommandOutput } from "../commands/ListAccountAssignmentCreationStatusCommand";
import { ListAccountAssignmentDeletionStatusCommandInput, ListAccountAssignmentDeletionStatusCommandOutput } from "../commands/ListAccountAssignmentDeletionStatusCommand";
import { ListAccountAssignmentsCommandInput, ListAccountAssignmentsCommandOutput } from "../commands/ListAccountAssignmentsCommand";
import { ListAccountAssignmentsForPrincipalCommandInput, ListAccountAssignmentsForPrincipalCommandOutput } from "../commands/ListAccountAssignmentsForPrincipalCommand";
import { ListAccountsForProvisionedPermissionSetCommandInput, ListAccountsForProvisionedPermissionSetCommandOutput } from "../commands/ListAccountsForProvisionedPermissionSetCommand";
import { ListApplicationAccessScopesCommandInput, ListApplicationAccessScopesCommandOutput } from "../commands/ListApplicationAccessScopesCommand";
import { ListApplicationAssignmentsCommandInput, ListApplicationAssignmentsCommandOutput } from "../commands/ListApplicationAssignmentsCommand";
import { ListApplicationAssignmentsForPrincipalCommandInput, ListApplicationAssignmentsForPrincipalCommandOutput } from "../commands/ListApplicationAssignmentsForPrincipalCommand";
import { ListApplicationAuthenticationMethodsCommandInput, ListApplicationAuthenticationMethodsCommandOutput } from "../commands/ListApplicationAuthenticationMethodsCommand";
import { ListApplicationGrantsCommandInput, ListApplicationGrantsCommandOutput } from "../commands/ListApplicationGrantsCommand";
import { ListApplicationProvidersCommandInput, ListApplicationProvidersCommandOutput } from "../commands/ListApplicationProvidersCommand";
import { ListApplicationsCommandInput, ListApplicationsCommandOutput } from "../commands/ListApplicationsCommand";
import { ListCustomerManagedPolicyReferencesInPermissionSetCommandInput, ListCustomerManagedPolicyReferencesInPermissionSetCommandOutput } from "../commands/ListCustomerManagedPolicyReferencesInPermissionSetCommand";
import { ListInstancesCommandInput, ListInstancesCommandOutput } from "../commands/ListInstancesCommand";
import { ListManagedPoliciesInPermissionSetCommandInput, ListManagedPoliciesInPermissionSetCommandOutput } from "../commands/ListManagedPoliciesInPermissionSetCommand";
import { ListPermissionSetProvisioningStatusCommandInput, ListPermissionSetProvisioningStatusCommandOutput } from "../commands/ListPermissionSetProvisioningStatusCommand";
import { ListPermissionSetsCommandInput, ListPermissionSetsCommandOutput } from "../commands/ListPermissionSetsCommand";
import { ListPermissionSetsProvisionedToAccountCommandInput, ListPermissionSetsProvisionedToAccountCommandOutput } from "../commands/ListPermissionSetsProvisionedToAccountCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { ListTrustedTokenIssuersCommandInput, ListTrustedTokenIssuersCommandOutput } from "../commands/ListTrustedTokenIssuersCommand";
import { ProvisionPermissionSetCommandInput, ProvisionPermissionSetCommandOutput } from "../commands/ProvisionPermissionSetCommand";
import { PutApplicationAccessScopeCommandInput, PutApplicationAccessScopeCommandOutput } from "../commands/PutApplicationAccessScopeCommand";
import { PutApplicationAssignmentConfigurationCommandInput, PutApplicationAssignmentConfigurationCommandOutput } from "../commands/PutApplicationAssignmentConfigurationCommand";
import { PutApplicationAuthenticationMethodCommandInput, PutApplicationAuthenticationMethodCommandOutput } from "../commands/PutApplicationAuthenticationMethodCommand";
import { PutApplicationGrantCommandInput, PutApplicationGrantCommandOutput } from "../commands/PutApplicationGrantCommand";
import { PutInlinePolicyToPermissionSetCommandInput, PutInlinePolicyToPermissionSetCommandOutput } from "../commands/PutInlinePolicyToPermissionSetCommand";
import { PutPermissionsBoundaryToPermissionSetCommandInput, PutPermissionsBoundaryToPermissionSetCommandOutput } from "../commands/PutPermissionsBoundaryToPermissionSetCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateApplicationCommandInput, UpdateApplicationCommandOutput } from "../commands/UpdateApplicationCommand";
import { UpdateInstanceAccessControlAttributeConfigurationCommandInput, UpdateInstanceAccessControlAttributeConfigurationCommandOutput } from "../commands/UpdateInstanceAccessControlAttributeConfigurationCommand";
import { UpdateInstanceCommandInput, UpdateInstanceCommandOutput } from "../commands/UpdateInstanceCommand";
import { UpdatePermissionSetCommandInput, UpdatePermissionSetCommandOutput } from "../commands/UpdatePermissionSetCommand";
import { UpdateTrustedTokenIssuerCommandInput, UpdateTrustedTokenIssuerCommandOutput } from "../commands/UpdateTrustedTokenIssuerCommand";
/**
 * serializeAws_json1_1AttachCustomerManagedPolicyReferenceToPermissionSetCommand
 */
export declare const se_AttachCustomerManagedPolicyReferenceToPermissionSetCommand: (input: AttachCustomerManagedPolicyReferenceToPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1AttachManagedPolicyToPermissionSetCommand
 */
export declare const se_AttachManagedPolicyToPermissionSetCommand: (input: AttachManagedPolicyToPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateAccountAssignmentCommand
 */
export declare const se_CreateAccountAssignmentCommand: (input: CreateAccountAssignmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateApplicationCommand
 */
export declare const se_CreateApplicationCommand: (input: CreateApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateApplicationAssignmentCommand
 */
export declare const se_CreateApplicationAssignmentCommand: (input: CreateApplicationAssignmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateInstanceCommand
 */
export declare const se_CreateInstanceCommand: (input: CreateInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateInstanceAccessControlAttributeConfigurationCommand
 */
export declare const se_CreateInstanceAccessControlAttributeConfigurationCommand: (input: CreateInstanceAccessControlAttributeConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreatePermissionSetCommand
 */
export declare const se_CreatePermissionSetCommand: (input: CreatePermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateTrustedTokenIssuerCommand
 */
export declare const se_CreateTrustedTokenIssuerCommand: (input: CreateTrustedTokenIssuerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteAccountAssignmentCommand
 */
export declare const se_DeleteAccountAssignmentCommand: (input: DeleteAccountAssignmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteApplicationCommand
 */
export declare const se_DeleteApplicationCommand: (input: DeleteApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteApplicationAccessScopeCommand
 */
export declare const se_DeleteApplicationAccessScopeCommand: (input: DeleteApplicationAccessScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteApplicationAssignmentCommand
 */
export declare const se_DeleteApplicationAssignmentCommand: (input: DeleteApplicationAssignmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteApplicationAuthenticationMethodCommand
 */
export declare const se_DeleteApplicationAuthenticationMethodCommand: (input: DeleteApplicationAuthenticationMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteApplicationGrantCommand
 */
export declare const se_DeleteApplicationGrantCommand: (input: DeleteApplicationGrantCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteInlinePolicyFromPermissionSetCommand
 */
export declare const se_DeleteInlinePolicyFromPermissionSetCommand: (input: DeleteInlinePolicyFromPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteInstanceCommand
 */
export declare const se_DeleteInstanceCommand: (input: DeleteInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteInstanceAccessControlAttributeConfigurationCommand
 */
export declare const se_DeleteInstanceAccessControlAttributeConfigurationCommand: (input: DeleteInstanceAccessControlAttributeConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeletePermissionsBoundaryFromPermissionSetCommand
 */
export declare const se_DeletePermissionsBoundaryFromPermissionSetCommand: (input: DeletePermissionsBoundaryFromPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeletePermissionSetCommand
 */
export declare const se_DeletePermissionSetCommand: (input: DeletePermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteTrustedTokenIssuerCommand
 */
export declare const se_DeleteTrustedTokenIssuerCommand: (input: DeleteTrustedTokenIssuerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeAccountAssignmentCreationStatusCommand
 */
export declare const se_DescribeAccountAssignmentCreationStatusCommand: (input: DescribeAccountAssignmentCreationStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeAccountAssignmentDeletionStatusCommand
 */
export declare const se_DescribeAccountAssignmentDeletionStatusCommand: (input: DescribeAccountAssignmentDeletionStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeApplicationCommand
 */
export declare const se_DescribeApplicationCommand: (input: DescribeApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeApplicationAssignmentCommand
 */
export declare const se_DescribeApplicationAssignmentCommand: (input: DescribeApplicationAssignmentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeApplicationProviderCommand
 */
export declare const se_DescribeApplicationProviderCommand: (input: DescribeApplicationProviderCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeInstanceCommand
 */
export declare const se_DescribeInstanceCommand: (input: DescribeInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeInstanceAccessControlAttributeConfigurationCommand
 */
export declare const se_DescribeInstanceAccessControlAttributeConfigurationCommand: (input: DescribeInstanceAccessControlAttributeConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribePermissionSetCommand
 */
export declare const se_DescribePermissionSetCommand: (input: DescribePermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribePermissionSetProvisioningStatusCommand
 */
export declare const se_DescribePermissionSetProvisioningStatusCommand: (input: DescribePermissionSetProvisioningStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeTrustedTokenIssuerCommand
 */
export declare const se_DescribeTrustedTokenIssuerCommand: (input: DescribeTrustedTokenIssuerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetachCustomerManagedPolicyReferenceFromPermissionSetCommand
 */
export declare const se_DetachCustomerManagedPolicyReferenceFromPermissionSetCommand: (input: DetachCustomerManagedPolicyReferenceFromPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetachManagedPolicyFromPermissionSetCommand
 */
export declare const se_DetachManagedPolicyFromPermissionSetCommand: (input: DetachManagedPolicyFromPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetApplicationAccessScopeCommand
 */
export declare const se_GetApplicationAccessScopeCommand: (input: GetApplicationAccessScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetApplicationAssignmentConfigurationCommand
 */
export declare const se_GetApplicationAssignmentConfigurationCommand: (input: GetApplicationAssignmentConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetApplicationAuthenticationMethodCommand
 */
export declare const se_GetApplicationAuthenticationMethodCommand: (input: GetApplicationAuthenticationMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetApplicationGrantCommand
 */
export declare const se_GetApplicationGrantCommand: (input: GetApplicationGrantCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetInlinePolicyForPermissionSetCommand
 */
export declare const se_GetInlinePolicyForPermissionSetCommand: (input: GetInlinePolicyForPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPermissionsBoundaryForPermissionSetCommand
 */
export declare const se_GetPermissionsBoundaryForPermissionSetCommand: (input: GetPermissionsBoundaryForPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAccountAssignmentCreationStatusCommand
 */
export declare const se_ListAccountAssignmentCreationStatusCommand: (input: ListAccountAssignmentCreationStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAccountAssignmentDeletionStatusCommand
 */
export declare const se_ListAccountAssignmentDeletionStatusCommand: (input: ListAccountAssignmentDeletionStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAccountAssignmentsCommand
 */
export declare const se_ListAccountAssignmentsCommand: (input: ListAccountAssignmentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAccountAssignmentsForPrincipalCommand
 */
export declare const se_ListAccountAssignmentsForPrincipalCommand: (input: ListAccountAssignmentsForPrincipalCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAccountsForProvisionedPermissionSetCommand
 */
export declare const se_ListAccountsForProvisionedPermissionSetCommand: (input: ListAccountsForProvisionedPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationAccessScopesCommand
 */
export declare const se_ListApplicationAccessScopesCommand: (input: ListApplicationAccessScopesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationAssignmentsCommand
 */
export declare const se_ListApplicationAssignmentsCommand: (input: ListApplicationAssignmentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationAssignmentsForPrincipalCommand
 */
export declare const se_ListApplicationAssignmentsForPrincipalCommand: (input: ListApplicationAssignmentsForPrincipalCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationAuthenticationMethodsCommand
 */
export declare const se_ListApplicationAuthenticationMethodsCommand: (input: ListApplicationAuthenticationMethodsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationGrantsCommand
 */
export declare const se_ListApplicationGrantsCommand: (input: ListApplicationGrantsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationProvidersCommand
 */
export declare const se_ListApplicationProvidersCommand: (input: ListApplicationProvidersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListApplicationsCommand
 */
export declare const se_ListApplicationsCommand: (input: ListApplicationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListCustomerManagedPolicyReferencesInPermissionSetCommand
 */
export declare const se_ListCustomerManagedPolicyReferencesInPermissionSetCommand: (input: ListCustomerManagedPolicyReferencesInPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListInstancesCommand
 */
export declare const se_ListInstancesCommand: (input: ListInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListManagedPoliciesInPermissionSetCommand
 */
export declare const se_ListManagedPoliciesInPermissionSetCommand: (input: ListManagedPoliciesInPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListPermissionSetProvisioningStatusCommand
 */
export declare const se_ListPermissionSetProvisioningStatusCommand: (input: ListPermissionSetProvisioningStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListPermissionSetsCommand
 */
export declare const se_ListPermissionSetsCommand: (input: ListPermissionSetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListPermissionSetsProvisionedToAccountCommand
 */
export declare const se_ListPermissionSetsProvisionedToAccountCommand: (input: ListPermissionSetsProvisionedToAccountCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTrustedTokenIssuersCommand
 */
export declare const se_ListTrustedTokenIssuersCommand: (input: ListTrustedTokenIssuersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ProvisionPermissionSetCommand
 */
export declare const se_ProvisionPermissionSetCommand: (input: ProvisionPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutApplicationAccessScopeCommand
 */
export declare const se_PutApplicationAccessScopeCommand: (input: PutApplicationAccessScopeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutApplicationAssignmentConfigurationCommand
 */
export declare const se_PutApplicationAssignmentConfigurationCommand: (input: PutApplicationAssignmentConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutApplicationAuthenticationMethodCommand
 */
export declare const se_PutApplicationAuthenticationMethodCommand: (input: PutApplicationAuthenticationMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutApplicationGrantCommand
 */
export declare const se_PutApplicationGrantCommand: (input: PutApplicationGrantCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutInlinePolicyToPermissionSetCommand
 */
export declare const se_PutInlinePolicyToPermissionSetCommand: (input: PutInlinePolicyToPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutPermissionsBoundaryToPermissionSetCommand
 */
export declare const se_PutPermissionsBoundaryToPermissionSetCommand: (input: PutPermissionsBoundaryToPermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateApplicationCommand
 */
export declare const se_UpdateApplicationCommand: (input: UpdateApplicationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateInstanceCommand
 */
export declare const se_UpdateInstanceCommand: (input: UpdateInstanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateInstanceAccessControlAttributeConfigurationCommand
 */
export declare const se_UpdateInstanceAccessControlAttributeConfigurationCommand: (input: UpdateInstanceAccessControlAttributeConfigurationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePermissionSetCommand
 */
export declare const se_UpdatePermissionSetCommand: (input: UpdatePermissionSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateTrustedTokenIssuerCommand
 */
export declare const se_UpdateTrustedTokenIssuerCommand: (input: UpdateTrustedTokenIssuerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1AttachCustomerManagedPolicyReferenceToPermissionSetCommand
 */
export declare const de_AttachCustomerManagedPolicyReferenceToPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachCustomerManagedPolicyReferenceToPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1AttachManagedPolicyToPermissionSetCommand
 */
export declare const de_AttachManagedPolicyToPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AttachManagedPolicyToPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1CreateAccountAssignmentCommand
 */
export declare const de_CreateAccountAssignmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateAccountAssignmentCommandOutput>;
/**
 * deserializeAws_json1_1CreateApplicationCommand
 */
export declare const de_CreateApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateApplicationCommandOutput>;
/**
 * deserializeAws_json1_1CreateApplicationAssignmentCommand
 */
export declare const de_CreateApplicationAssignmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateApplicationAssignmentCommandOutput>;
/**
 * deserializeAws_json1_1CreateInstanceCommand
 */
export declare const de_CreateInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateInstanceCommandOutput>;
/**
 * deserializeAws_json1_1CreateInstanceAccessControlAttributeConfigurationCommand
 */
export declare const de_CreateInstanceAccessControlAttributeConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateInstanceAccessControlAttributeConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1CreatePermissionSetCommand
 */
export declare const de_CreatePermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1CreateTrustedTokenIssuerCommand
 */
export declare const de_CreateTrustedTokenIssuerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateTrustedTokenIssuerCommandOutput>;
/**
 * deserializeAws_json1_1DeleteAccountAssignmentCommand
 */
export declare const de_DeleteAccountAssignmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAccountAssignmentCommandOutput>;
/**
 * deserializeAws_json1_1DeleteApplicationCommand
 */
export declare const de_DeleteApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApplicationCommandOutput>;
/**
 * deserializeAws_json1_1DeleteApplicationAccessScopeCommand
 */
export declare const de_DeleteApplicationAccessScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApplicationAccessScopeCommandOutput>;
/**
 * deserializeAws_json1_1DeleteApplicationAssignmentCommand
 */
export declare const de_DeleteApplicationAssignmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApplicationAssignmentCommandOutput>;
/**
 * deserializeAws_json1_1DeleteApplicationAuthenticationMethodCommand
 */
export declare const de_DeleteApplicationAuthenticationMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApplicationAuthenticationMethodCommandOutput>;
/**
 * deserializeAws_json1_1DeleteApplicationGrantCommand
 */
export declare const de_DeleteApplicationGrantCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApplicationGrantCommandOutput>;
/**
 * deserializeAws_json1_1DeleteInlinePolicyFromPermissionSetCommand
 */
export declare const de_DeleteInlinePolicyFromPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInlinePolicyFromPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1DeleteInstanceCommand
 */
export declare const de_DeleteInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInstanceCommandOutput>;
/**
 * deserializeAws_json1_1DeleteInstanceAccessControlAttributeConfigurationCommand
 */
export declare const de_DeleteInstanceAccessControlAttributeConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInstanceAccessControlAttributeConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1DeletePermissionsBoundaryFromPermissionSetCommand
 */
export declare const de_DeletePermissionsBoundaryFromPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePermissionsBoundaryFromPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1DeletePermissionSetCommand
 */
export declare const de_DeletePermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1DeleteTrustedTokenIssuerCommand
 */
export declare const de_DeleteTrustedTokenIssuerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteTrustedTokenIssuerCommandOutput>;
/**
 * deserializeAws_json1_1DescribeAccountAssignmentCreationStatusCommand
 */
export declare const de_DescribeAccountAssignmentCreationStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAccountAssignmentCreationStatusCommandOutput>;
/**
 * deserializeAws_json1_1DescribeAccountAssignmentDeletionStatusCommand
 */
export declare const de_DescribeAccountAssignmentDeletionStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeAccountAssignmentDeletionStatusCommandOutput>;
/**
 * deserializeAws_json1_1DescribeApplicationCommand
 */
export declare const de_DescribeApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeApplicationCommandOutput>;
/**
 * deserializeAws_json1_1DescribeApplicationAssignmentCommand
 */
export declare const de_DescribeApplicationAssignmentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeApplicationAssignmentCommandOutput>;
/**
 * deserializeAws_json1_1DescribeApplicationProviderCommand
 */
export declare const de_DescribeApplicationProviderCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeApplicationProviderCommandOutput>;
/**
 * deserializeAws_json1_1DescribeInstanceCommand
 */
export declare const de_DescribeInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceCommandOutput>;
/**
 * deserializeAws_json1_1DescribeInstanceAccessControlAttributeConfigurationCommand
 */
export declare const de_DescribeInstanceAccessControlAttributeConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceAccessControlAttributeConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1DescribePermissionSetCommand
 */
export declare const de_DescribePermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1DescribePermissionSetProvisioningStatusCommand
 */
export declare const de_DescribePermissionSetProvisioningStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePermissionSetProvisioningStatusCommandOutput>;
/**
 * deserializeAws_json1_1DescribeTrustedTokenIssuerCommand
 */
export declare const de_DescribeTrustedTokenIssuerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTrustedTokenIssuerCommandOutput>;
/**
 * deserializeAws_json1_1DetachCustomerManagedPolicyReferenceFromPermissionSetCommand
 */
export declare const de_DetachCustomerManagedPolicyReferenceFromPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachCustomerManagedPolicyReferenceFromPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1DetachManagedPolicyFromPermissionSetCommand
 */
export declare const de_DetachManagedPolicyFromPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetachManagedPolicyFromPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1GetApplicationAccessScopeCommand
 */
export declare const de_GetApplicationAccessScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApplicationAccessScopeCommandOutput>;
/**
 * deserializeAws_json1_1GetApplicationAssignmentConfigurationCommand
 */
export declare const de_GetApplicationAssignmentConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApplicationAssignmentConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1GetApplicationAuthenticationMethodCommand
 */
export declare const de_GetApplicationAuthenticationMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApplicationAuthenticationMethodCommandOutput>;
/**
 * deserializeAws_json1_1GetApplicationGrantCommand
 */
export declare const de_GetApplicationGrantCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApplicationGrantCommandOutput>;
/**
 * deserializeAws_json1_1GetInlinePolicyForPermissionSetCommand
 */
export declare const de_GetInlinePolicyForPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetInlinePolicyForPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1GetPermissionsBoundaryForPermissionSetCommand
 */
export declare const de_GetPermissionsBoundaryForPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPermissionsBoundaryForPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1ListAccountAssignmentCreationStatusCommand
 */
export declare const de_ListAccountAssignmentCreationStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAccountAssignmentCreationStatusCommandOutput>;
/**
 * deserializeAws_json1_1ListAccountAssignmentDeletionStatusCommand
 */
export declare const de_ListAccountAssignmentDeletionStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAccountAssignmentDeletionStatusCommandOutput>;
/**
 * deserializeAws_json1_1ListAccountAssignmentsCommand
 */
export declare const de_ListAccountAssignmentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAccountAssignmentsCommandOutput>;
/**
 * deserializeAws_json1_1ListAccountAssignmentsForPrincipalCommand
 */
export declare const de_ListAccountAssignmentsForPrincipalCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAccountAssignmentsForPrincipalCommandOutput>;
/**
 * deserializeAws_json1_1ListAccountsForProvisionedPermissionSetCommand
 */
export declare const de_ListAccountsForProvisionedPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAccountsForProvisionedPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationAccessScopesCommand
 */
export declare const de_ListApplicationAccessScopesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationAccessScopesCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationAssignmentsCommand
 */
export declare const de_ListApplicationAssignmentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationAssignmentsCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationAssignmentsForPrincipalCommand
 */
export declare const de_ListApplicationAssignmentsForPrincipalCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationAssignmentsForPrincipalCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationAuthenticationMethodsCommand
 */
export declare const de_ListApplicationAuthenticationMethodsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationAuthenticationMethodsCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationGrantsCommand
 */
export declare const de_ListApplicationGrantsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationGrantsCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationProvidersCommand
 */
export declare const de_ListApplicationProvidersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationProvidersCommandOutput>;
/**
 * deserializeAws_json1_1ListApplicationsCommand
 */
export declare const de_ListApplicationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListApplicationsCommandOutput>;
/**
 * deserializeAws_json1_1ListCustomerManagedPolicyReferencesInPermissionSetCommand
 */
export declare const de_ListCustomerManagedPolicyReferencesInPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListCustomerManagedPolicyReferencesInPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1ListInstancesCommand
 */
export declare const de_ListInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListInstancesCommandOutput>;
/**
 * deserializeAws_json1_1ListManagedPoliciesInPermissionSetCommand
 */
export declare const de_ListManagedPoliciesInPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListManagedPoliciesInPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1ListPermissionSetProvisioningStatusCommand
 */
export declare const de_ListPermissionSetProvisioningStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPermissionSetProvisioningStatusCommandOutput>;
/**
 * deserializeAws_json1_1ListPermissionSetsCommand
 */
export declare const de_ListPermissionSetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPermissionSetsCommandOutput>;
/**
 * deserializeAws_json1_1ListPermissionSetsProvisionedToAccountCommand
 */
export declare const de_ListPermissionSetsProvisionedToAccountCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPermissionSetsProvisionedToAccountCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1ListTrustedTokenIssuersCommand
 */
export declare const de_ListTrustedTokenIssuersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTrustedTokenIssuersCommandOutput>;
/**
 * deserializeAws_json1_1ProvisionPermissionSetCommand
 */
export declare const de_ProvisionPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ProvisionPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1PutApplicationAccessScopeCommand
 */
export declare const de_PutApplicationAccessScopeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutApplicationAccessScopeCommandOutput>;
/**
 * deserializeAws_json1_1PutApplicationAssignmentConfigurationCommand
 */
export declare const de_PutApplicationAssignmentConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutApplicationAssignmentConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1PutApplicationAuthenticationMethodCommand
 */
export declare const de_PutApplicationAuthenticationMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutApplicationAuthenticationMethodCommandOutput>;
/**
 * deserializeAws_json1_1PutApplicationGrantCommand
 */
export declare const de_PutApplicationGrantCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutApplicationGrantCommandOutput>;
/**
 * deserializeAws_json1_1PutInlinePolicyToPermissionSetCommand
 */
export declare const de_PutInlinePolicyToPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutInlinePolicyToPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1PutPermissionsBoundaryToPermissionSetCommand
 */
export declare const de_PutPermissionsBoundaryToPermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutPermissionsBoundaryToPermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateApplicationCommand
 */
export declare const de_UpdateApplicationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateApplicationCommandOutput>;
/**
 * deserializeAws_json1_1UpdateInstanceCommand
 */
export declare const de_UpdateInstanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateInstanceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateInstanceAccessControlAttributeConfigurationCommand
 */
export declare const de_UpdateInstanceAccessControlAttributeConfigurationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateInstanceAccessControlAttributeConfigurationCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePermissionSetCommand
 */
export declare const de_UpdatePermissionSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePermissionSetCommandOutput>;
/**
 * deserializeAws_json1_1UpdateTrustedTokenIssuerCommand
 */
export declare const de_UpdateTrustedTokenIssuerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateTrustedTokenIssuerCommandOutput>;
